//Source file: CallAdditionalEventInfo.java
//Date: June 2004
//Multi Party Call Control Data Types for 3GPP TS 29.198-04-3 V5.7.0

package org.csapi.jr.se.cc;

/**
 * Defines the Tagged Choice of Data Elements that specify additional call event information for certain types of events. 
 *
 */
public final class CallAdditionalEventInfo implements java.io.Serializable {

    private CallEventType _discriminator = null;
    private java.lang.Object _object;

    /**
     * Creates a new CallAdditionalEventInfo.
     * Tagged choice of data elements always have empty constructors
     */ 
    public CallAdditionalEventInfo() {}

    /**
     * This method returns the discriminator.
     * 
     * @return a CallEventType value 
     * @exception InvalidUnionAccessorException if an error occurs 
     */ 
    public CallEventType getDiscriminator() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator == null) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return _discriminator;
    }

    /**
     * This method returns a TerminatingServiceCode
     * 
     * @return  a org.csapi.jr.se.cc.CallServiceCode value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.cc.CallServiceCode getTerminatingServiceCode() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallEventType.CALL_EVENT_TERMINATING_SERVICE_CODE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.cc.CallServiceCode) _object);
    }

    /**
     * This method sets a TerminatingServiceCode
     * 
     * @param value a org.csapi.jr.se.cc.CallServiceCode value
     */
    public void setTerminatingServiceCode(org.csapi.jr.se.cc.CallServiceCode value) {
        _discriminator = CallEventType.CALL_EVENT_TERMINATING_SERVICE_CODE;
        _object = value;
    }

    /**
     * This method returns a CollectedAddress
     * 
     * @return  a org.csapi.jr.se.Address value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.Address getCollectedAddress() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallEventType.CALL_EVENT_ADDRESS_COLLECTED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.Address) _object);
    }

    /**
     * This method sets a CollectedAddress
     * 
     * @param value a org.csapi.jr.se.Address value
     */
    public void setCollectedAddress(org.csapi.jr.se.Address value) {
        _discriminator = CallEventType.CALL_EVENT_ADDRESS_COLLECTED;
        _object = value;
    }

    /**
     * This method returns a CalledAddress
     * 
     * @return  a org.csapi.jr.se.Address value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.Address getCalledAddress() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallEventType.CALL_EVENT_ADDRESS_ANALYSED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.Address) _object);
    }

    /**
     * This method sets a CalledAddress
     * 
     * @param value a org.csapi.jr.se.Address value
     */
    public void setCalledAddress(org.csapi.jr.se.Address value) {
        _discriminator = CallEventType.CALL_EVENT_ADDRESS_ANALYSED;
        _object = value;
    }

    /**
     * This method returns a ForwardAddress
     * 
     * @return  a org.csapi.jr.se.Address value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.Address getForwardAddress() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallEventType.CALL_EVENT_REDIRECTED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.Address) _object);
    }

    /**
     * This method sets a ForwardAddress
     * 
     * @param value a org.csapi.jr.se.Address value
     */
    public void setForwardAddress(org.csapi.jr.se.Address value) {
        _discriminator = CallEventType.CALL_EVENT_REDIRECTED;
        _object = value;
    }

    /**
     * This method returns a OriginatingReleaseCause
     * 
     * @return  a org.csapi.jr.se.cc.ReleaseCause value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.cc.ReleaseCause getOriginatingReleaseCause() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallEventType.CALL_EVENT_ORIGINATING_RELEASE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.cc.ReleaseCause) _object);
    }

    /**
     * This method sets a OriginatingReleaseCause
     * 
     * @param value a org.csapi.jr.se.cc.ReleaseCause value
     */
    public void setOriginatingReleaseCause(org.csapi.jr.se.cc.ReleaseCause value) {
        _discriminator = CallEventType.CALL_EVENT_ORIGINATING_RELEASE;
        _object = value;
    }

    /**
     * This method returns a OriginatingServiceCode
     * 
     * @return  a org.csapi.jr.se.cc.CallServiceCode value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.cc.CallServiceCode getOriginatingServiceCode() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallEventType.CALL_EVENT_ORIGINATING_SERVICE_CODE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.cc.CallServiceCode) _object);
    }

    /**
     * This method sets a OriginatingServiceCode
     * 
     * @param value a org.csapi.jr.se.cc.CallServiceCode value
     */
    public void setOriginatingServiceCode(org.csapi.jr.se.cc.CallServiceCode value) {
        _discriminator = CallEventType.CALL_EVENT_ORIGINATING_SERVICE_CODE;
        _object = value;
    }

    /**
     * This method returns a TerminatingReleaseCause
     * 
     * @return  a org.csapi.jr.se.cc.ReleaseCause value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.cc.ReleaseCause getTerminatingReleaseCause() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallEventType.CALL_EVENT_TERMINATING_RELEASE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.cc.ReleaseCause) _object);
    }

    /**
     * This method sets a TerminatingReleaseCause
     * 
     * @param value a org.csapi.jr.se.cc.ReleaseCause value
     */
    public void setTerminatingReleaseCause(org.csapi.jr.se.cc.ReleaseCause value) {
        _discriminator = CallEventType.CALL_EVENT_TERMINATING_RELEASE;
        _object = value;
    }


    /**
     * This method will receive the discriminator as a parameter and will set _object to null
     * 
     * @param discriminator a CallEventType value 
     */ 
    public void setUndefined(CallEventType discriminator) {
        _discriminator = discriminator;
        _object = null;
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) {
            return false;
        }
        if(!(o instanceof CallAdditionalEventInfo)) {
            return false;
        } else {
            CallAdditionalEventInfo callAdditionalEventInfo= (CallAdditionalEventInfo)o;
            if(!(this._object.equals(callAdditionalEventInfo._object))){
                return false;
            } else {
                if(!(this._discriminator.equals(callAdditionalEventInfo._discriminator))){
                    return false;
                }
            }
            if (this.hashCode() != o.hashCode()) {
                return false;
            }
            return true;
        }
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // CallAdditionalEventInfo

