//Source file: CallEventInfo.java
//Date: June 2004
//Multi Party Call Control Data Types for 3GPP TS 29.198-04-3 V5.7.0

package org.csapi.jr.se.cc;

/**
 * Defines the Sequence of Data Elements that specify the event report specific information. 
 * 
 */
public final class CallEventInfo implements java.io.Serializable {

    private org.csapi.jr.se.cc.CallEventType callEventType;
    private org.csapi.jr.se.cc.CallAdditionalEventInfo additionalCallEventInfo;
    private org.csapi.jr.se.cc.CallMonitorMode callMonitorMode;
    private String callEventTime;

    /**
     * Creates a new CallEventInfo instance.
     */
    public CallEventInfo () {}

    /**
     * Creates a new CallEventInfo instance.
     * @param _callEventType   
     * @param _additionalCallEventInfo   
     * @param _callMonitorMode   
     * @param _callEventTime   
     */
    public CallEventInfo (org.csapi.jr.se.cc.CallEventType _callEventType, org.csapi.jr.se.cc.CallAdditionalEventInfo _additionalCallEventInfo, org.csapi.jr.se.cc.CallMonitorMode _callMonitorMode, String _callEventTime) {

        this.callEventType = _callEventType;
        this.additionalCallEventInfo = _additionalCallEventInfo;
        this.callMonitorMode = _callMonitorMode;
        this.callEventTime = _callEventTime;
    }

    /**
     * This method returns a callEventType.
     * 
     * @return a org.csapi.jr.se.cc.CallEventType value
     */
    public org.csapi.jr.se.cc.CallEventType getCallEventType() {
        return callEventType;
    }

    /**
     * This method returns a additionalCallEventInfo.
     * 
     * @return a org.csapi.jr.se.cc.CallAdditionalEventInfo value
     */
    public org.csapi.jr.se.cc.CallAdditionalEventInfo getAdditionalCallEventInfo() {
        return additionalCallEventInfo;
    }

    /**
     * This method returns a callMonitorMode.
     * 
     * @return a org.csapi.jr.se.cc.CallMonitorMode value
     */
    public org.csapi.jr.se.cc.CallMonitorMode getCallMonitorMode() {
        return callMonitorMode;
    }

    /**
     * This method returns a callEventTime.
     * 
     * @return a String value
     */
    public String getCallEventTime() {
        return callEventTime;
    }


    /**
     * This method sets a callEventType.
     */ 
    public void setCallEventType(org.csapi.jr.se.cc.CallEventType callEventType) {
        this.callEventType = callEventType;
    }

    /**
     * This method sets a additionalCallEventInfo.
     */ 
    public void setAdditionalCallEventInfo(org.csapi.jr.se.cc.CallAdditionalEventInfo additionalCallEventInfo) {
        this.additionalCallEventInfo = additionalCallEventInfo;
    }

    /**
     * This method sets a callMonitorMode.
     */ 
    public void setCallMonitorMode(org.csapi.jr.se.cc.CallMonitorMode callMonitorMode) {
        this.callMonitorMode = callMonitorMode;
    }

    /**
     * This method sets a callEventTime.
     */ 
    public void setCallEventTime(String callEventTime) {
        this.callEventTime = callEventTime;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof CallEventInfo)) {
            return false;
        } 
        CallEventInfo callEventInfo = (CallEventInfo) o;
        if ((this.callEventType != null) && (callEventInfo.callEventType != null)) {
            if(!(this.callEventType.equals(callEventInfo.callEventType))) {
                return false;
            }
        }
        if ((this.additionalCallEventInfo != null) && (callEventInfo.additionalCallEventInfo != null)) {
            if(!(this.additionalCallEventInfo.equals(callEventInfo.additionalCallEventInfo))) {
                return false;
            }
        }
        if ((this.callMonitorMode != null) && (callEventInfo.callMonitorMode != null)) {
            if(!(this.callMonitorMode.equals(callEventInfo.callMonitorMode))) {
                return false;
            }
        }
        if(!(this.callEventTime == callEventInfo.callEventTime))  {
            return false;
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // CallEventInfo

