//Source file: CallEventRequest.java
//Date: June 2004
//Multi Party Call Control Data Types for 3GPP TS 29.198-04-3 V5.7.0

package org.csapi.jr.se.cc;

/**
 * Defines the Sequence of Data Elements that specify the criteria relating to call event requests.
 * 
 */
public final class CallEventRequest implements java.io.Serializable {

    private org.csapi.jr.se.cc.CallEventType callEventType;
    private org.csapi.jr.se.cc.AdditionalCallEventCriteria additionalCallEventCriteria;
    private org.csapi.jr.se.cc.CallMonitorMode callMonitorMode;

    /**
     * Creates a new CallEventRequest instance.
     */
    public CallEventRequest () {}

    /**
     * Creates a new CallEventRequest instance.
     * @param _callEventType   
     * @param _additionalCallEventCriteria   
     * @param _callMonitorMode   
     */
    public CallEventRequest (org.csapi.jr.se.cc.CallEventType _callEventType, org.csapi.jr.se.cc.AdditionalCallEventCriteria _additionalCallEventCriteria, org.csapi.jr.se.cc.CallMonitorMode _callMonitorMode) {

        this.callEventType = _callEventType;
        this.additionalCallEventCriteria = _additionalCallEventCriteria;
        this.callMonitorMode = _callMonitorMode;
    }

    /**
     * This method returns a callEventType.
     * 
     * @return a org.csapi.jr.se.cc.CallEventType value
     */
    public org.csapi.jr.se.cc.CallEventType getCallEventType() {
        return callEventType;
    }

    /**
     * This method returns a additionalCallEventCriteria.
     * 
     * @return a org.csapi.jr.se.cc.AdditionalCallEventCriteria value
     */
    public org.csapi.jr.se.cc.AdditionalCallEventCriteria getAdditionalCallEventCriteria() {
        return additionalCallEventCriteria;
    }

    /**
     * This method returns a callMonitorMode.
     * 
     * @return a org.csapi.jr.se.cc.CallMonitorMode value
     */
    public org.csapi.jr.se.cc.CallMonitorMode getCallMonitorMode() {
        return callMonitorMode;
    }


    /**
     * This method sets a callEventType.
     */ 
    public void setCallEventType(org.csapi.jr.se.cc.CallEventType callEventType) {
        this.callEventType = callEventType;
    }

    /**
     * This method sets a additionalCallEventCriteria.
     */ 
    public void setAdditionalCallEventCriteria(org.csapi.jr.se.cc.AdditionalCallEventCriteria additionalCallEventCriteria) {
        this.additionalCallEventCriteria = additionalCallEventCriteria;
    }

    /**
     * This method sets a callMonitorMode.
     */ 
    public void setCallMonitorMode(org.csapi.jr.se.cc.CallMonitorMode callMonitorMode) {
        this.callMonitorMode = callMonitorMode;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof CallEventRequest)) {
            return false;
        } 
        CallEventRequest callEventRequest = (CallEventRequest) o;
        if ((this.callEventType != null) && (callEventRequest.callEventType != null)) {
            if(!(this.callEventType.equals(callEventRequest.callEventType))) {
                return false;
            }
        }
        if ((this.additionalCallEventCriteria != null) && (callEventRequest.additionalCallEventCriteria != null)) {
            if(!(this.additionalCallEventCriteria.equals(callEventRequest.additionalCallEventCriteria))) {
                return false;
            }
        }
        if ((this.callMonitorMode != null) && (callEventRequest.callMonitorMode != null)) {
            if(!(this.callMonitorMode.equals(callEventRequest.callMonitorMode))) {
                return false;
            }
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // CallEventRequest

