//Source file: CallNotificationInfo.java
//Date: June 2004
//Multi Party Call Control Data Types for 3GPP TS 29.198-04-3 V5.7.0

package org.csapi.jr.se.cc;

/**
 * Defines the Sequence of Data Elements that specify the information returned to the application in a Call notification report.
 * 
 */
public final class CallNotificationInfo implements java.io.Serializable {

    private org.csapi.jr.se.cc.CallNotificationReportScope callNotificationReportScope;
    private org.csapi.jr.se.cc.CallAppInfo[] callAppInfo;
    private org.csapi.jr.se.cc.CallEventInfo callEventInfo;

    /**
     * Creates a new CallNotificationInfo instance.
     */
    public CallNotificationInfo () {}

    /**
     * Creates a new CallNotificationInfo instance.
     * @param _callNotificationReportScope   Defines the scope of the notification report.
     * @param _callAppInfo   Contains additional call info.
     * @param _callEventInfo   Contains the event which is reported.
     */
    public CallNotificationInfo (org.csapi.jr.se.cc.CallNotificationReportScope _callNotificationReportScope, org.csapi.jr.se.cc.CallAppInfo[] _callAppInfo, org.csapi.jr.se.cc.CallEventInfo _callEventInfo) {

        this.callNotificationReportScope = _callNotificationReportScope;
        this.callAppInfo = _callAppInfo;
        this.callEventInfo = _callEventInfo;
    }

    /**
     * This method returns a callNotificationReportScope.
     * 
     * @return a org.csapi.jr.se.cc.CallNotificationReportScope value
     */
    public org.csapi.jr.se.cc.CallNotificationReportScope getCallNotificationReportScope() {
        return callNotificationReportScope;
    }

    /**
     * This method returns a callAppInfo.
     * 
     * @return a org.csapi.jr.se.cc.CallAppInfo[] value
     */
    public org.csapi.jr.se.cc.CallAppInfo[] getCallAppInfo() {
        return callAppInfo;
    }

    /**
     * This method returns a callEventInfo.
     * 
     * @return a org.csapi.jr.se.cc.CallEventInfo value
     */
    public org.csapi.jr.se.cc.CallEventInfo getCallEventInfo() {
        return callEventInfo;
    }


    /**
     * This method sets a callNotificationReportScope.
     */ 
    public void setCallNotificationReportScope(org.csapi.jr.se.cc.CallNotificationReportScope callNotificationReportScope) {
        this.callNotificationReportScope = callNotificationReportScope;
    }

    /**
     * This method sets a callAppInfo.
     */ 
    public void setCallAppInfo(org.csapi.jr.se.cc.CallAppInfo[] callAppInfo) {
        this.callAppInfo = callAppInfo;
    }

    /**
     * This method sets a callEventInfo.
     */ 
    public void setCallEventInfo(org.csapi.jr.se.cc.CallEventInfo callEventInfo) {
        this.callEventInfo = callEventInfo;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof CallNotificationInfo)) {
            return false;
        } 
        CallNotificationInfo callNotificationInfo = (CallNotificationInfo) o;
        if ((this.callNotificationReportScope != null) && (callNotificationInfo.callNotificationReportScope != null)) {
            if(!(this.callNotificationReportScope.equals(callNotificationInfo.callNotificationReportScope))) {
                return false;
            }
        }
        if(!(this.callAppInfo == callNotificationInfo.callAppInfo))  {
            return false;
        }
        if ((this.callEventInfo != null) && (callNotificationInfo.callEventInfo != null)) {
            if(!(this.callEventInfo.equals(callNotificationInfo.callEventInfo))) {
                return false;
            }
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // CallNotificationInfo

