//Source file: EventReportResEvent.java
//Date: June 2004
//Multi Party Call Control Interfaces for 3GPP TS 29.198-04-3 V5.7.0

package org.csapi.jr.se.cc.mpccs;

/**
 * Event created by an activity object to indicate that a Gateway originated 
 * call to the eventReportRes() method on the callback interface 
 * has occured.<BR>
 *
 */
public final class EventReportResEvent extends java.util.EventObject {

    /**
     * Constructor for the EventReportResEvent Event.
     *
     * @param  source      Reference to the object firing the event.<BR>
     */
    public EventReportResEvent(java.lang.Object source,
        org.csapi.jr.se.cc.CallEventInfo eventInfo) {

        super(source);
      this.eventInfo = eventInfo;
 
    }

    org.csapi.jr.se.cc.CallEventInfo eventInfo;

    /**
     *  This method is used to retrieve the parameter value of 'eventInfo' passed up
     *  from the Gateway in it's call to the eventReportRes() method, used on
     *  the creation of this event.
     *
     * @return    The value of 'eventInfo' used on creation of this event.
     */
    public org.csapi.jr.se.cc.CallEventInfo getEventInfo() {

        return this.eventInfo;
    }
       
}

