//Source file: MultiPartyCallListener.java
//Date: June 2004
//Multi Party Call Control Interfaces for 3GPP TS 29.198-04-3 V5.7.0

package org.csapi.jr.se.cc.mpccs;

/**
 * This interface is to be implemented for receiving events issued by the MultiPartyCall service object.<BR>
 *
 */
public interface MultiPartyCallListener extends java.util.EventListener {


   /**
    * Called due to a Gateway initiated call to the getInfoRes() method on 
    * the callback interface.
    *
    * @param  getInfoResEvent  Reference to a GetInfoResEvent event 
    *        emmited from the impl or activity object. 
    */
    void onGetInfoResEvent(org.csapi.jr.se.cc.mpccs.GetInfoResEvent getInfoResEvent);


   /**
    * Called due to a Gateway initiated call to the getInfoErr() method on 
    * the callback interface.
    *
    * @param  getInfoErrEvent  Reference to a GetInfoErrEvent event 
    *        emmited from the impl or activity object. 
    */
    void onGetInfoErrEvent(org.csapi.jr.se.cc.mpccs.GetInfoErrEvent getInfoErrEvent);


   /**
    * Called due to a Gateway initiated call to the superviseRes() method on 
    * the callback interface.
    *
    * @param  superviseResEvent  Reference to a SuperviseResEvent event 
    *        emmited from the impl or activity object. 
    */
    void onSuperviseResEvent(org.csapi.jr.se.cc.mpccs.SuperviseResEvent superviseResEvent);


   /**
    * Called due to a Gateway initiated call to the superviseErr() method on 
    * the callback interface.
    *
    * @param  superviseErrEvent  Reference to a SuperviseErrEvent event 
    *        emmited from the impl or activity object. 
    */
    void onSuperviseErrEvent(org.csapi.jr.se.cc.mpccs.SuperviseErrEvent superviseErrEvent);


   /**
    * Called due to a Gateway initiated call to the callEnded() method on 
    * the callback interface.
    *
    * @param  callEndedEvent  Reference to a CallEndedEvent event 
    *        emmited from the impl or activity object. 
    */
    void onCallEndedEvent(org.csapi.jr.se.cc.mpccs.CallEndedEvent callEndedEvent);


   /**
    * Called due to a Gateway initiated call to the createAndRouteCallLegErr() method on 
    * the callback interface.
    *
    * @param  createAndRouteCallLegErrEvent  Reference to a CreateAndRouteCallLegErrEvent event 
    *        emmited from the impl or activity object. 
    */
    void onCreateAndRouteCallLegErrEvent(org.csapi.jr.se.cc.mpccs.CreateAndRouteCallLegErrEvent createAndRouteCallLegErrEvent);

}

